Index: /LMDZ5/trunk/libf/dyn3d/infotrac.F90
===================================================================
--- /LMDZ5/trunk/libf/dyn3d/infotrac.F90	(revision 1564)
+++ /LMDZ5/trunk/libf/dyn3d/infotrac.F90	(revision 1565)
@@ -32,5 +32,7 @@
   SUBROUTINE infotrac_init
     USE control_mod
-
+#ifdef REPROBUS
+    USE CHEM_REP, ONLY : Init_chem_rep_trac
+#endif
     IMPLICIT NONE
 !=======================================================================
@@ -94,4 +96,6 @@
           CALL abort_gcm('infotrac_init','Incoherence between type_trac and config_inca',1)
        END IF
+    ELSE IF (type_trac=='repr') THEN
+       WRITE(lunout,*) 'You have choosen to couple with REPROBUS chemestry model : type_trac=', type_trac
     ELSE IF (type_trac == 'lmdz') THEN
        WRITE(lunout,*) 'Tracers are treated in LMDZ only : type_trac=', type_trac
@@ -115,5 +119,5 @@
 !
 !-----------------------------------------------------------------------
-    IF (type_trac == 'lmdz') THEN
+    IF (type_trac == 'lmdz' .OR. type_trac == 'repr') THEN
        OPEN(90,file='traceur.def',form='formatted',status='old', iostat=ierr)
        IF(ierr.EQ.0) THEN
@@ -147,4 +151,10 @@
     END IF
     
+! Transfert number of tracers to Reprobus
+    IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+       CALL Init_chem_rep_trac(nbtr)
+#endif
+    END IF
        
 !
@@ -182,5 +192,5 @@
 !    Get choice of advection schema from file tracer.def or from INCA
 !---------------------------------------------------------------------
-    IF (type_trac == 'lmdz') THEN
+    IF (type_trac == 'lmdz' .OR. type_trac == 'repr') THEN
        IF(ierr.EQ.0) THEN
           ! Continue to read tracer.def
Index: /LMDZ5/trunk/libf/dyn3dpar/infotrac.F90
===================================================================
--- /LMDZ5/trunk/libf/dyn3dpar/infotrac.F90	(revision 1564)
+++ /LMDZ5/trunk/libf/dyn3dpar/infotrac.F90	(revision 1565)
@@ -32,5 +32,7 @@
   SUBROUTINE infotrac_init
     USE control_mod
-
+#ifdef REPROBUS
+    USE CHEM_REP, ONLY : Init_chem_rep_trac
+#endif
     IMPLICIT NONE
 !=======================================================================
@@ -94,4 +96,6 @@
           CALL abort_gcm('infotrac_init','Incoherence between type_trac and config_inca',1)
        END IF
+    ELSE IF (type_trac=='repr') THEN
+       WRITE(lunout,*) 'You have choosen to couple with REPROBUS chemestry model : type_trac=', type_trac
     ELSE IF (type_trac == 'lmdz') THEN
        WRITE(lunout,*) 'Tracers are treated in LMDZ only : type_trac=', type_trac
@@ -115,5 +119,5 @@
 !
 !-----------------------------------------------------------------------
-    IF (type_trac == 'lmdz') THEN
+    IF (type_trac == 'lmdz' .OR. type_trac == 'repr') THEN
        OPEN(90,file='traceur.def',form='formatted',status='old', iostat=ierr)
        IF(ierr.EQ.0) THEN
@@ -147,4 +151,10 @@
     END IF
     
+! Transfert number of tracers to Reprobus
+    IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+       CALL Init_chem_rep_trac(nbtr)
+#endif
+    END IF
        
 !
@@ -182,5 +192,5 @@
 !    Get choice of advection schema from file tracer.def or from INCA
 !---------------------------------------------------------------------
-    IF (type_trac == 'lmdz') THEN
+    IF (type_trac == 'lmdz' .OR. type_trac == 'repr') THEN
        IF(ierr.EQ.0) THEN
           ! Continue to read tracer.def
Index: /LMDZ5/trunk/libf/phylmd/init_phys_lmdz.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/init_phys_lmdz.F90	(revision 1564)
+++ /LMDZ5/trunk/libf/phylmd/init_phys_lmdz.F90	(revision 1565)
@@ -6,4 +6,9 @@
   USE mod_grid_phy_lmdz
   USE dimphy, ONLY : Init_dimphy
+  USE infotrac, ONLY : type_trac
+#ifdef REPROBUS
+  USE CHEM_REP, ONLY : Init_chem_rep_phys
+#endif
+
   IMPLICIT NONE
   
@@ -19,4 +24,12 @@
 !$OMP PARALLEL
     CALL Init_dimphy(klon_omp,nbp_lev)
+
+! Initialization of Reprobus
+    IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+       CALL Init_chem_rep_phys(klon_omp,nbp_lev)
+#endif
+    END IF
+
 !$OMP END PARALLEL
  
Index: /LMDZ5/trunk/libf/phylmd/physiq.F
===================================================================
--- /LMDZ5/trunk/libf/phylmd/physiq.F	(revision 1564)
+++ /LMDZ5/trunk/libf/phylmd/physiq.F	(revision 1565)
@@ -42,4 +42,7 @@
       use radlwsw_m, only: radlwsw
       USE control_mod
+#ifdef REPROBUS
+      USE CHEM_REP, ONLY : Init_chem_rep_xjour
+#endif
 
 
@@ -1215,4 +1218,6 @@
       REAL, dimension(klon, klev) :: cldtaurad  ! epaisseur optique pour radlwsw,COSP
       REAL, dimension(klon, klev) :: cldemirad  ! emissivite pour radlwsw,COSP 
+      INTEGER :: nbtr_tmp ! Number of tracer inside concvl
+      REAL, dimension(klon,klev) :: sh_in ! Specific humidity entering in phytrac
 
 cIM for NMC files
@@ -1736,4 +1741,15 @@
       CALL change_srf_frac(itap, dtime, days_elapsed+1, 
      *     pctsrf, falb1, falb2, ftsol, u10m, v10m, pbl_tke)
+
+
+! Update time and other variables in Reprobus
+      IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+         CALL Init_chem_rep_xjour(jD_cur-jD_ref+day_ref)
+         print*,'xjour equivalent rjourvrai',jD_cur-jD_ref+day_ref
+         CALL Rtime(debut)
+#endif
+      END IF
+
 
 ! Tendances bidons pour les processus qui n'affectent pas certaines
@@ -2288,8 +2304,13 @@
           IF (ok_cvl) THEN ! new driver for convectL
 
+             IF (type_trac == 'repr') THEN
+                nbtr_tmp=ntra
+             ELSE
+                nbtr_tmp=nbtr
+             END IF
           CALL concvl (iflag_con,iflag_clos,
      .        dtime,paprs,pplay,t_undi,q_undi,
      .        t_wake,q_wake,wake_s,
-     .        u_seri,v_seri,tr_seri,nbtr,
+     .        u_seri,v_seri,tr_seri,nbtr_tmp,
      .        ALE,ALP,
      .        ema_work1,ema_work2,
@@ -3664,4 +3685,10 @@
 C
 
+       IF (type_trac=='repr') THEN
+          sh_in(:,:) = q_seri(:,:)
+       ELSE
+          sh_in(:,:) = qx(:,:,ivap)
+       END IF
+
       call phytrac (
      I     itap,     days_elapsed+1,    jH_cur,   debut,
@@ -3673,5 +3700,5 @@
      I     rlat,     frac_impa, frac_nucl,rlon,
      I     presnivs, pphis,     pphi,     albsol1,
-     I     qx(:,:,ivap),rhcl,   cldfra,   rneb, 
+     I     sh_in,    rhcl,      cldfra,   rneb, 
      I     diafra,   cldliq,    itop_con, ibas_con,
      I     pmflxr,   pmflxs,    prfl,     psfl,
Index: /LMDZ5/trunk/libf/phylmd/phytrac.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phytrac.F90	(revision 1564)
+++ /LMDZ5/trunk/libf/phylmd/phytrac.F90	(revision 1565)
@@ -33,6 +33,6 @@
   USE traclmdz_mod
   USE tracinca_mod
+  USE tracreprobus_mod
   USE control_mod
-
 
 
@@ -55,5 +55,5 @@
   INTEGER,INTENT(IN) :: nstep      ! Appel physique
   INTEGER,INTENT(IN) :: julien     ! Jour julien
-  REAL,INTENT(IN)    :: gmtime
+  REAL,INTENT(IN)    :: gmtime     ! Heure courante
   REAL,INTENT(IN)    :: pdtphys    ! Pas d'integration pour la physique (seconde)
   LOGICAL,INTENT(IN) :: debutphy   ! le flag de l'initialisation de la physique
@@ -217,4 +217,6 @@
         source(:,:)=0.
         CALL tracinca_init(aerosol,lessivage)
+     CASE('repr')
+        source(:,:)=0.
      END SELECT
 !
@@ -257,4 +259,13 @@
           rfname,                                        &
           tr_seri,  source,   solsym)      
+
+  CASE('repr')
+     !   -- CHIMIE REPROBUS --
+
+     CALL tracreprobus(pdtphys, gmtime, debutphy, julien, &
+          presnivs, xlat, xlon, pphis, pphi, &
+          t_seri, pplay, paprs, sh , &
+          tr_seri, solsym)
+     
   END SELECT
 
Index: /LMDZ5/trunk/libf/phylmd/radiation_AR4.F
===================================================================
--- /LMDZ5/trunk/libf/phylmd/radiation_AR4.F	(revision 1564)
+++ /LMDZ5/trunk/libf/phylmd/radiation_AR4.F	(revision 1565)
@@ -163,14 +163,11 @@
         allocate(ZFSUPAI(KDLON,KFLEV+1))
         allocate(ZFSDNAI(KDLON,KFLEV+1))
-        DO JK = 1 , KDLON*(KFLEV+1)
-          ZFSUPAD(JK,1) = 0.0     ! ZFSUPAD(:,:)=0.
-          ZFSDNAD(JK,1) = 0.0     ! ZFSDNAD(:,:)=0.
-          ZFSUPAI(JK,1) = 0.0     ! ZFSUPAI(:,:)=0.
-          ZFSDNAI(JK,1) = 0.0     ! ZFSDNAI(:,:)=0.
-        END DO
+
+        ZFSUPAD(:,:)=0.
+        ZFSDNAD(:,:)=0.
+        ZFSUPAI(:,:)=0.
+        ZFSDNAI(:,:)=0.
       endif
-!rv
-      
-c
+
       IF (appel1er) THEN
          PRINT*, 'SW calling frequency : ', swpas
@@ -526,4 +523,9 @@
       USE dimphy
       USE radiation_AR4_param, only : RSUN, RRAY
+      USE infotrac, ONLY : type_trac
+#ifdef REPROBUS
+      USE CHEM_REP, ONLY : RSUNTIME, ok_SUNTIME
+#endif
+
       IMPLICIT none
 cym#include "dimensions.h"
@@ -613,4 +615,16 @@
       INTEGER jl, jk, k, jaj, ikm1, ikl
 
+C If running with Reporbus, overwrite default values of RSUN. 
+C Otherwise keep default values from radiation_AR4_param module.  
+      IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+         IF (ok_SUNTIME) THEN
+            RSUN(1) = RSUNTIME(1)
+            RSUN(2) = RSUNTIME(2)
+         ENDIF
+         PRINT*,'RSUN(1): ',RSUN(1)
+#endif
+      END IF
+
 C     ------------------------------------------------------------------
 C
@@ -754,4 +768,9 @@
       USE dimphy
       USE radiation_AR4_param, only : RSUN, RRAY
+      USE infotrac, ONLY : type_trac
+#ifdef REPROBUS
+      use CHEM_REP, only : RSUNTIME, ok_SUNTIME
+#endif
+
       IMPLICIT none
 cym#include "dimensions.h"
@@ -873,4 +892,16 @@
       INTEGER jref, jkl, jklp1, jajp, jkki, jkkp4, jn2j, iabs
       REAL(KIND=8) ZRMUM1, ZWH2O, ZCNEB, ZAA, ZBB, ZRKI, ZRE11
+
+C If running with Reporbus, overwrite default values of RSUN. 
+C Otherwise keep default values from radiation_AR4_param module.  
+      IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+         IF (ok_SUNTIME) THEN
+            RSUN(1)=RSUNTIME(1)
+            RSUN(2)=RSUNTIME(2)
+         END IF
+#endif
+      END IF
+
 C
 
@@ -2485,4 +2516,13 @@
       USE dimphy
       USE radiation_AR4_param, only : TREF, RT1, RAER, AT, BT, OCT
+      USE infotrac, ONLY : type_trac
+#ifdef REPROBUS
+      USE CHEM_REP, ONLY: RCH42D,
+     $                    RN2O2D,
+     $                    RCFC112D,
+     $                    RCFC122D,
+     $                    ok_Rtime2D
+#endif
+
       IMPLICIT none
 cym#include "dimensions.h"
@@ -2800,17 +2840,55 @@
      S                +ZUAER(JL,5)    *ZDUC(JL,JC)*ZDIFF
 C
-      PABCU(JL,19,JC)=PABCU(JL,19,JCP1)
-     S               +ZABLY(JL,8,JC)*RCH4/RCO2*ZPHM6(JL)*ZDIFF
-      PABCU(JL,20,JC)=PABCU(JL,20,JCP1)
+C
+
+      IF (type_trac == 'repr') THEN
+         IF (ok_Rtime2D) THEN
+#ifdef REPROBUS
+            PABCU(JL,19,JC)=PABCU(JL,19,JCP1)
+     S           +ZABLY(JL,8,JC)*RCH42D(JL,JC)/RCO2*ZPHM6(JL)*ZDIFF
+            PABCU(JL,20,JC)=PABCU(JL,20,JCP1)
+     S           +ZABLY(JL,9,JC)*RCH42D(JL,JC)/RCO2*ZPSM6(JL)*ZDIFF
+            PABCU(JL,21,JC)=PABCU(JL,21,JCP1)
+     S           +ZABLY(JL,8,JC)*RN2O2D(JL,JC)/RCO2*ZPHN6(JL)*ZDIFF
+            PABCU(JL,22,JC)=PABCU(JL,22,JCP1)
+     S           +ZABLY(JL,9,JC)*RN2O2D(JL,JC)/RCO2*ZPSN6(JL)*ZDIFF
+C
+            PABCU(JL,23,JC)=PABCU(JL,23,JCP1)
+     S           +ZABLY(JL,8,JC)*RCFC112D(JL,JC)/RCO2         *ZDIFF
+            PABCU(JL,24,JC)=PABCU(JL,24,JCP1)
+     S           +ZABLY(JL,8,JC)*RCFC122D(JL,JC)/RCO2         *ZDIFF
+#endif
+         ELSE
+            ! Same calculation as for type_trac /= repr
+            PABCU(JL,19,JC)=PABCU(JL,19,JCP1)
+     S           +ZABLY(JL,8,JC)*RCH4/RCO2*ZPHM6(JL)*ZDIFF
+            PABCU(JL,20,JC)=PABCU(JL,20,JCP1)
+     S           +ZABLY(JL,9,JC)*RCH4/RCO2*ZPSM6(JL)*ZDIFF
+            PABCU(JL,21,JC)=PABCU(JL,21,JCP1)
+     S           +ZABLY(JL,8,JC)*RN2O/RCO2*ZPHN6(JL)*ZDIFF
+            PABCU(JL,22,JC)=PABCU(JL,22,JCP1)
+     S           +ZABLY(JL,9,JC)*RN2O/RCO2*ZPSN6(JL)*ZDIFF
+C     
+            PABCU(JL,23,JC)=PABCU(JL,23,JCP1)
+     S               +ZABLY(JL,8,JC)*RCFC11/RCO2         *ZDIFF
+            PABCU(JL,24,JC)=PABCU(JL,24,JCP1)
+     S           +ZABLY(JL,8,JC)*RCFC12/RCO2         *ZDIFF
+         END IF
+      ELSE
+         PABCU(JL,19,JC)=PABCU(JL,19,JCP1)
+     S        +ZABLY(JL,8,JC)*RCH4/RCO2*ZPHM6(JL)*ZDIFF
+         PABCU(JL,20,JC)=PABCU(JL,20,JCP1)
      S               +ZABLY(JL,9,JC)*RCH4/RCO2*ZPSM6(JL)*ZDIFF
-      PABCU(JL,21,JC)=PABCU(JL,21,JCP1)
-     S               +ZABLY(JL,8,JC)*RN2O/RCO2*ZPHN6(JL)*ZDIFF
-      PABCU(JL,22,JC)=PABCU(JL,22,JCP1)
-     S               +ZABLY(JL,9,JC)*RN2O/RCO2*ZPSN6(JL)*ZDIFF
-C
-      PABCU(JL,23,JC)=PABCU(JL,23,JCP1)
-     S               +ZABLY(JL,8,JC)*RCFC11/RCO2         *ZDIFF
-      PABCU(JL,24,JC)=PABCU(JL,24,JCP1)
-     S               +ZABLY(JL,8,JC)*RCFC12/RCO2         *ZDIFF
+         PABCU(JL,21,JC)=PABCU(JL,21,JCP1)
+     S        +ZABLY(JL,8,JC)*RN2O/RCO2*ZPHN6(JL)*ZDIFF
+         PABCU(JL,22,JC)=PABCU(JL,22,JCP1)
+     S        +ZABLY(JL,9,JC)*RN2O/RCO2*ZPSN6(JL)*ZDIFF
+C     
+         PABCU(JL,23,JC)=PABCU(JL,23,JCP1)
+     S        +ZABLY(JL,8,JC)*RCFC11/RCO2         *ZDIFF
+         PABCU(JL,24,JC)=PABCU(JL,24,JCP1)
+     S        +ZABLY(JL,8,JC)*RCFC12/RCO2         *ZDIFF
+      END IF
+      
  523  CONTINUE
  524  CONTINUE
Index: /LMDZ5/trunk/libf/phylmd/radiation_AR4_param.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/radiation_AR4_param.F90	(revision 1564)
+++ /LMDZ5/trunk/libf/phylmd/radiation_AR4_param.F90	(revision 1565)
@@ -159,5 +159,6 @@
       0.90811926E+01,  0.75073923E+02,  0.24654438E+03,  0.39332612E+03,  0.29385281E+03,  0.89107921E+02 /) , (/ 6,6 /) )
 
-      REAL*8, dimension(2), parameter :: RSUN = (/ 0.441676 , 0.558324 /)
+! If running with Reporbus type_trac=repr, values of RSUN might be overritten in radiation_AR4
+      REAL*8, dimension(2) :: RSUN = (/ 0.441676 , 0.558324 /)
       REAL*8, dimension(2,6), parameter :: RRAY = reshape ( &
          (/ .428937E-01, .697200E-02,&
Index: /LMDZ5/trunk/libf/phylmd/radlwsw.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/radlwsw.F90	(revision 1564)
+++ /LMDZ5/trunk/libf/phylmd/radlwsw.F90	(revision 1565)
@@ -30,5 +30,9 @@
 
   USE DIMPHY
-  use assert_m, only: assert
+  USE assert_m, ONLY : assert
+  USE infotrac, ONLY : type_trac
+#ifdef REPROBUS
+  USE CHEM_REP, ONLY : solaireTIME, ok_SUNTIME, ndimozon
+#endif
 
   !======================================================================
@@ -229,4 +233,12 @@
   !
   PSCT = solaire/zdist/zdist
+
+  IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+     if(ok_SUNTIME) PSCT = solaireTIME/zdist/zdist
+     print*,'Constante solaire: ',PSCT*zdist*zdist
+#endif
+  END IF
+
   DO j = 1, nb_gr
     iof = kdlon*(j-1)
@@ -281,4 +293,12 @@
       ENDDO
     ENDDO
+
+    IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+       ndimozon = size(wo, 3)
+       CALL RAD_INTERACTIF(POZON,iof)
+#endif
+    END IF
+
     !
     DO k = 1, kflev+1
Index: /LMDZ5/trunk/libf/phylmd/tracreprobus_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/tracreprobus_mod.F90	(revision 1565)
+++ /LMDZ5/trunk/libf/phylmd/tracreprobus_mod.F90	(revision 1565)
@@ -0,0 +1,109 @@
+MODULE tracreprobus_mod
+!
+! This module prepares and calls the Reprobus main subroutine 
+!
+
+CONTAINS
+
+  SUBROUTINE tracreprobus(pdtphys, gmtime, debutphy, julien, &
+       presnivs, xlat, xlon, pphis, pphi, &
+       t_seri, pplay, paprs, sh , &
+       tr_seri, solsym)
+
+    USE dimphy
+    USE infotrac
+#ifdef REPROBUS 
+    USE CHEM_REP, ONLY : pdt_rep, &  ! pas de temps reprobus
+         daynum, iter, &             ! jourjulien, iteration chimie
+         pdel
+#endif
+    IMPLICIT NONE
+
+! Input argument
+!---------------
+    REAL,INTENT(IN)    :: pdtphys    ! Pas d'integration pour la physique (seconde)
+    REAL,INTENT(IN)    :: gmtime     ! Heure courante
+    LOGICAL,INTENT(IN) :: debutphy   ! le flag de l'initialisation de la physique
+    INTEGER,INTENT(IN) :: julien     ! Jour julien
+
+    REAL,DIMENSION(klev),INTENT(IN)        :: presnivs! pressions approximat. des milieux couches (en PA)
+    REAL,DIMENSION(klon),INTENT(IN)        :: xlat    ! latitudes pour chaque point 
+    REAL,DIMENSION(klon),INTENT(IN)        :: xlon    ! longitudes pour chaque point 
+    REAL,DIMENSION(klon),INTENT(IN)        :: pphis   ! geopotentiel du sol
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: pphi    ! geopotentiel de chaque couche
+
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: t_seri  ! Temperature
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: pplay   ! pression pour le mileu de chaque couche (en Pa)
+    REAL,DIMENSION(klon,klev+1),INTENT(IN) :: paprs   ! pression pour chaque inter-couche (en Pa)
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: sh      ! humidite specifique   
+
+
+! Output argument
+!----------------
+    REAL,DIMENSION(klon,klev,nbtr),INTENT(INOUT)  :: tr_seri ! Concentration Traceur [U/KgA]  
+    CHARACTER(len=8),DIMENSION(nbtr), INTENT(OUT) :: solsym
+  
+
+! Local variables
+!----------------
+    INTEGER :: it, k
+
+
+    !   -- CHIMIE REPROBUS --
+    pdt_rep=pdtphys/2.
+    
+    DO k = 1, klev
+       pdel(:,k) = paprs(:,k) - paprs (:,k+1)
+    END DO
+    
+    ! initialisation de ozone passif a ozone en debut d hiver HN et HS
+    IF (julien == 341 .OR. julien == 181) THEN
+       tr_seri(:,:,11)=tr_seri(:,:,8)
+    END IF
+    
+    DO  iter = 1,2
+       daynum = FLOAT(julien) + gmtime + (iter-1)*pdt_rep/86400.
+       
+       DO it=1, nbtr
+!     WRITE(lunout,*)it,' ',minval(tr_seri(:,:,it)),maxval(tr_seri(:,:,it))
+! seulement pour les especes chimiques (pas l'age de l'air)
+! verif valeurs extremes
+! correction: a 1.e-30 quand =0 ou negatif et
+! call abort si >ou= 1.e10
+          WRITE(*,*)it,'nqtot',nqtot,'nbtr',nbtr
+          IF (it < nqtot) THEN
+             WRITE(*,*)'ici',it,nqtot
+#ifdef REPROBUS
+             CALL minmaxqfi_chimie(tr_seri(1,1,it),0.,1.e10,'avant chimie ')
+#endif
+             WRITE(*,*)'apres'
+          ENDIF
+       ENDDO
+       
+#ifdef REPROBUS
+       CALL chemmain_rlong_1401( &
+            tr_seri, & !argument phytrac (change de nom apres: vmr)
+            xlon,    & !argument phytrac (change de nom apres: lon)
+            xlat,    & !argument phytrac (change de nom apres: lat)
+            t_seri,  & !argument phytrac (meme nom)
+            pplay,   & !argument phytrac (meme nom)
+            pphi,    & !argument phytrac (meme nom)
+            pphis,   & !argument phytrac (meme nom)
+            presnivs, & !argument phytrac (meme nom)
+            sh,      & !argument phytrac (meme nom)
+            debutphy) !argument phytrac (change de nom apres: debut)
+       ! pdel, pdt_rep, daynum : definit dans phytrac et utilise dans chemmain
+       !                 et transporte par CHEM_REP
+#endif        
+       
+    END DO
+    
+
+    ! 
+    DO it=1,nbtr
+       WRITE(solsym(it),'(i2)') it
+    END DO
+
+  END SUBROUTINE tracreprobus
+
+END MODULE tracreprobus_mod